# AddThis Plugin for Movable Type
# Author: The AddThis Team
# Author URI: http://www.addthis.com
#
# +--------------------------------------------------------------------------+
# | Copyright (c) 2009 Add This, LLC                                         |
# +--------------------------------------------------------------------------+
# | This program is free software; you can redistribute it and/or modify     |
# | it under the terms of the GNU General Public License as published by     |
# | the Free Software Foundation; either version 3 of the License, or        |
# | (at your option) any later version.                                      |
# |                                                                          |
# | This program is distributed in the hope that it will be useful,          |
# | but WITHOUT ANY WARRANTY; without even the implied warranty of           |
# | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            |
# | GNU General Public License for more details.                             |
# |                                                                          |
# | You should have received a copy of the GNU General Public License        |
# | along with this program.  If not, see <http://www.gnu.org/licenses/>.    |
# +--------------------------------------------------------------------------+

package AddThis::Plugin;
use strict;
use MT::App;
use base 'MT::App';

# getButtonImage is used for preparing the language specific button name. 
sub getButtonImage {
	
	my $buttonImage = "";

	  if( $_[0] ne "sm-plus" )
	  {
		  if( $_[1] ne 'en' and $_[1] ne 'Select' )
		   {
			  	if( $_[0] eq 'lg-share' || $_[0] eq 'lg-bookmark' || $_[0] eq 'lg-addthis' )
			  	{
				  	$buttonImage = 'lg-share-'.$_[1].'.gif';
			  	}
			  	else 
			  	{
					  if( $_[0] eq 'sm-share' || $_[0]  eq 'sm-bookmark' )
					  {
						  $buttonImage = 'sm-share-'.$_[1].'.gif';
					  }
				}
		  	}
			else
			{
				if($_[1] ne 'Select')
				{
			  		$buttonImage = $_[0].'-'.$_[1].'.gif';
			  	}
				else
				{
					$buttonImage = $_[0].'-en.gif';
				}
			}
	  }
	  else
	  {
	   		$buttonImage = $_[0].'.gif';
	  }

	  return $buttonImage;
}


#
# The method AddButton will prepare the script for AddThis Button.
#
#
sub AddButton {
    my ($ctx, $args, $cond) = @_;
    my $out = "";
    my $entry = $ctx->stash('entry');
    my $id = $ctx->stash('id');
    my $blog_id = $ctx->stash('blog_id');
    my $url = ($entry) ? $entry->permalink : '[URL]';
    my $title = ($entry) ? $entry->title : '[TITLE]';
	
	# Loding the configuration object to $plugin.
   	my $plugin = MT->component("AddThis");
    my $scope = "blog:" . $blog_id;
	
	# Assigning plugin parameters to local variables.
	my $pub_id 			= $plugin->get_config_value('pub_id',$scope);
	my $button_image 		= $plugin->get_config_value('button_image',$scope);
	my $button_language 	= $plugin->get_config_value('button_language',$scope);
	my $brand_name 		= $plugin->get_config_value('brand_name',$scope);
	my $header_color 		= $plugin->get_config_value('header_color',$scope);
	my $header_background 	= $plugin->get_config_value('header_background',$scope);
	my $addthis_options 	= $plugin->get_config_value('addthis_options',$scope);
	my $addthis_offset_top 	= $plugin->get_config_value('addthis_offset_top',$scope);
	my $addthis_offset_left = $plugin->get_config_value('addthis_offset_left',$scope);
	my $addthis_hover_delay = $plugin->get_config_value('addthis_hover_delay',$scope);
	my $addthis_hide_embed 	= $plugin->get_config_value('addthis_hide_embed',$scope);
	my $addthis_language 	= $plugin->get_config_value('addthis_language',$scope);

	my $image_name = "";
	$title =~ s/"/\\"/g;
	$title= CGI::escapeHTML($title);
	
	
	
	
	# Preparing the addthis button url.
	
	if( $button_image ne 'custom')
	{
		$image_name = 'http://s7.addthis.com/static/btn/'.&getButtonImage( $button_image , $button_language);
	}
	else
	{
		$image_name = $plugin->get_config_value('custom_url',$scope);
	}

	# Preparing the AddThis button script begins
	$out .= "\n<!-- AddThis Button BEGIN -->\n";
	$out .= "<script type='text/javascript'> \n";
	$out .= "var addthis_product = 'mtp-1.2';\n";

	if( $pub_id ne '')
	{
		$out .= " var addthis_pub ='".$pub_id."';\n";
	}
	if($url ne '')
	{
		#$out .= " var addthis_url ='".$url."';\n";
	}
	if($title ne '')
	{
		#$out .= " var addthis_title ='".$encoded_title."';\n";
	}
	if( $brand_name ne '')
	{
		$out .= " var addthis_brand = '".$brand_name."';\n";
	}
	if( $header_color ne '')
	{
		$out .= " var addthis_header_color = '".$header_color."';\n";
	}
	if( $header_background ne '')
	{
		$out .= " var addthis_header_background = '".$header_background."';\n";
	}
	if( $addthis_options ne '')
	{
		$out .= " var addthis_options ='".$addthis_options."';\n";
	}
	if( $addthis_offset_top ne '')
	{
		$out .= " var addthis_offset_top = ".$addthis_offset_top.";\n";
	}
	if( $addthis_offset_left ne '')
	{
		$out .= " var addthis_offset_left = ".$addthis_offset_left.";\n";
	}
	if( $addthis_hover_delay ne '')
	{
		$out .= " var addthis_hover_delay = ".$addthis_hover_delay.";\n" ;
	}
	if( $addthis_language ne '' and $addthis_language ne 'auto')
	{
		$out .= " var addthis_language = '".$addthis_language."';\n";
	}
    if( $addthis_hide_embed ne '' and $addthis_hide_embed ne 'true')
    {
        $out .= " var addthis_hide_embed = false;\n";
    }
	$out .= "</script>\n";
	$out .= '<a href="http://www.addthis.com/bookmark.php?v=250" ';
	$out .= ' onmouseover=\'return addthis_open(this,"", "'.$url.'", "'.$title.'" )\' ';
	$out .= ' onmouseout="addthis_close()" onclick="return addthis_sendto()"> ';
	$out .= ' <img src="'.$image_name.'"';
	$out .= '  alt="Bookmark and Share" style="border:0"/></a>';
	$out .= ' <script type="text/javascript" src="http://s7.addthis.com/js/250/addthis_widget.js"></script>';
	$out .= "\n<!-- AddThis Button END -->\n";	
	# AddThis button script preparation ends.
   
    return $out;
}



1; # Every module must return true
